
#include <SPI.h>              //SD
#include <SD.h>               //SD    ********MUST BE VERSION 1.2.2 TO WORK WITH TEENSY********


float var1 = 1;
float var2 = 0;
///////////////////piezo and photoresistor//////////////////////////////////
const int sensorPin = A2;
float piezo;
int whiteLed = 4;

int lightLevel, high = 600, low = 1023;
////////////////////////////////////////////////////////////////////////
// SD Card
File logFile;

//Uncomment the device that is being used.
//const int chipSelect = BUILTIN_SDCARD;      //For Devices such as Teensy 3.5 
const int chipSelect = 8;                     //For Devices such as Arduino Uno (External SDCard)

long int lastLogTime;
long int timeOffset=0;

//logData: Stores data to the an SD Card.
#define logData(logS)  {  Serial.print(logS);    \ 
                          Serial.print(",");     \
                          logFile.print(logS);   \
                          logFile.print(",");    \
                       }
//logDataE: Stores the last parameter on the SD Card and jumps to the next line.
#define logDataE(logS)  {  Serial.println(logS); \
                          logFile.println(logS); \
                          logFile.flush();       \
                       }
////////////////////////photo resistor and piezo//////////////
void sensorsetup()
{
  Serial.begin(9600);
   pinMode(whiteLed, OUTPUT);
   pinMode(A0, INPUT);
   pinMode(A2, INPUT);
}
void lightloop()
{

  lightLevel = analogRead(sensorPin);
  autoTune();  // manually change the range from light to dark
  analogWrite(whiteLed, lightLevel);
  piezoloop();// calls the piezo and photo sensor function
   
  }
 
void manualTune()
{
  lightLevel = map(lightLevel, 0, 1023, 0, 255);
  lightLevel = constrain(lightLevel, 0, 255);
}

void autoTune()
{
    if (lightLevel < low) {low = lightLevel;}
    if (lightLevel > high) {high = lightLevel;}
        
  lightLevel = map(lightLevel, low+30, high-30, 0, 255);
  lightLevel = constrain(lightLevel, 0, 255); 
}
void piezoloop()
{
  if (lightLevel == LOW){
   // put your main code here, to run repeatedly:
  int piezo = analogRead(A0);      //piezo is a local variable for the loop function.
  int photo = analogRead(A2);
  
  //Serial.println("The piezo value is:" + String(piezo));
  Serial.print(piezo);
  Serial.print("\t");
  Serial.println(photo);
  delay(100);
  
  if(piezo > 500){  
  digitalWrite(whiteLed,HIGH);
  delay(10000);
  Serial.println("The threshold is above 1000"); 
   }
  }
}

//////////////////////////////////////////////////

void setup() {
  char lineBuf[150];
  // Serial port for debugging
  Serial.begin(9600);

  // initialize SD card
  setup_SDcard();

  // open logfile
  if ((logFile = SD.open("datalog.csv", FILE_READ))) 
  {   
    while (logFile.available()) {
      logFile.readBytesUntil('\n',lineBuf,150);    
    }
  }

   
  // open logfile
  if (!(logFile = SD.open("datalog.csv", FILE_WRITE))) { 
    Serial.println("logfile failed to open");
    return;
    }
}

void loop() {
  long int currentTime;
  piezoloop();
  lightloop();

// get time
  currentTime=millis()+timeOffset;

// log the current state once a second
  if ((currentTime-lastLogTime)>1000) {
    logData(millis());
    logData(var1);
    logDataE(var2);
    lastLogTime=currentTime;

  }
}


//////////////////////////////////////////////////////////////////////////////////////////////
//                                    SD Card                                      ///
//////////////////////////////////////////////////////////////////////////////////////////////

void setup_SDcard() {
  Serial.print("Initializing SD card...");

  // see if the card is present and can be initialized:
  if (!SD.begin(chipSelect)) {
    Serial.println("Card failed, or not present");
    // don't do anything more:
    while (1);
  }
  Serial.println("card initialized.");
}
